--- old/usr/src/tools/smatch/src/smatch_data/db/fixup_kernel.sh	Mon Aug  5 08:38:23 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/fixup_kernel.sh	Mon Aug  5 08:38:23 2019
@@ -23,18 +23,8 @@
 delete from caller_info where function = '(struct net_device_ops)->ndo_change_mtu' and caller = 'i40e_dbg_netdev_ops_write';
 delete from caller_info where function = '(struct timer_list)->function' and type != 0;
 
-/* type 1003 is USER_DATA */
-delete from caller_info where caller = 'hid_input_report' and type = 1003;
-delete from caller_info where caller = 'nes_process_iwarp_aeqe' and type = 1003;
-delete from caller_info where caller = 'oz_process_ep0_urb' and type = 1003;
-delete from caller_info where function = 'dev_hard_start_xmit' and key = '\$' and type = 1003;
-delete from caller_info where function like '%->ndo_start_xmit' and key = '\$' and type = 1003;
-delete from caller_info where caller = 'packet_rcv_fanout' and function = '(struct packet_type)->func' and parameter = 1 and type = 1003;
-delete from caller_info where caller = 'hptiop_probe' and type = 1003;
-delete from caller_info where caller = 'p9_fd_poll' and function = '(struct file_operations)->poll' and type = 1003;
-delete from caller_info where caller = 'proc_reg_poll' and function = 'proc_reg_poll ptr poll' and type = 1003;
-delete from caller_info where function = 'blkdev_ioctl' and type = 1003 and parameter = 0 and key = '\$';
-/* 9017 is USER_DATA3_SET */
+/* 8017 is USER_DATA and  9017 is USER_DATA_SET */
+delete from caller_info where function = 'dev_hard_start_xmit' and type = 8017;
 delete from return_states where function='vscnprintf' and type = 9017;
 delete from return_states where function='scnprintf' and type = 9017;
 delete from return_states where function='vsnprintf' and type = 9017;
@@ -49,6 +39,10 @@
 /* because of recursion it gets passed to everything and is impossible to debug */
 delete from caller_info where function = '__dev_queue_xmit' and type = 8017;
 delete from caller_info where function = '__netdev_start_xmit' and type = 8017;
+delete from caller_info where function = '(struct packet_type)->func' and type = 8017;
+delete from caller_info where function = '(struct bio)->bi_end_io' and type = 8017;
+delete from caller_info where caller = 'NF_HOOK_COND' and type = 8017;
+delete from caller_info where caller = 'NF_HOOK' and type = 8017;
 /* comparison doesn't deal with chunks, I guess.  */
 delete from return_states where function='get_tty_driver' and type = 8017;
 delete from caller_info where caller = 'snd_ctl_elem_write' and function = '(struct snd_kcontrol)->put' and type = 8017;
@@ -57,9 +51,9 @@
 delete from caller_info where caller = 'fb_set_var' and function = '(struct fb_ops)->fb_set_par' and type = 8017 and parameter = 0;
 delete from return_states where function = 'tty_lookup_driver' and parameter = 2 and type = 8017;
 
-insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 1003, 0, '\$', '1');
-insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 1003, 1, '\$', '1');
-insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 1003, 2, '\$', '1');
+insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 8017, 0, '\$', '1');
+insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 8017, 1, '\$', '1');
+insert into caller_info values ('userspace', '', 'compat_sys_ioctl', 0, 0, 8017, 2, '\$', '1');
 
 delete from caller_info where function = '(struct timer_list)->function' and parameter = 0;
 
@@ -76,36 +70,15 @@
 
 delete from return_states where function = 'is_kernel_rodata';
 insert into return_states values ('faked', 'is_kernel_rodata', 0, 1, '1', 0, 0,   -1,  '', '');
-insert into return_states values ('faked', 'is_kernel_rodata', 0, 1, '1', 0, 103,  0,  '\$', '100000000-177777777');
+insert into return_states values ('faked', 'is_kernel_rodata', 0, 1, '1', 0, 103,  0,  '\$', '4096-ptr_max');
 insert into return_states values ('faked', 'is_kernel_rodata', 0, 2, '0', 0, 0,   -1,  '', '');
 
 /*
- * I am a bad person for doing this to __kmalloc() which is a very deep function
- * and can easily be removed instead of to kmalloc().  But kmalloc() is an
- * inline function so it ends up being recorded thousands of times in the
- * database.  Doing this is easier.
- *
- */
-delete from return_states where function = '__kmalloc';
-insert into return_states values ('faked', '__kmalloc', 0, 1, '16', 0,    0,  -1, '', '');
-insert into return_states values ('faked', '__kmalloc', 0, 1, '16', 0, 103,   0, '\$', '0');
-insert into return_states values ('faked', '__kmalloc', 0, 2, '0,500000000-577777777', 0,    0, -1, '', '');
-insert into return_states values ('faked', '__kmalloc', 0, 2, '0,500000000-577777777', 0, 103,  0, '\$', '1-4000000');
-insert into return_states values ('faked', '__kmalloc', 0, 2, '0,500000000-577777777', 0, 1037,  -1, '', 400);
-insert into return_states values ('faked', '__kmalloc', 0, 3, '0', 0,    0,  -1, '', '');
-insert into return_states values ('faked', '__kmalloc', 0, 3, '0', 0,    103,  0, '\$', '4000000-long_max');
-
-/*
  * Other kmalloc hacking.
  */
-update return_states set return = '0,500000000-577777777' where function = 'kmalloc_slab' and return = 's64min-s64max';
-update return_states set return = '0,500000000-577777777' where function = 'slab_alloc_node' and return = 's64min-s64max';
-update return_states set return = '0,500000000-577777777' where function = 'kmalloc_large' and return != '0';
-update return_states set return = '0,500000000-577777777' where function = 'kmalloc_order_trace' and return != '0';
-
 delete from return_states where function = 'vmalloc';
-insert into return_states values ('faked', 'vmalloc', 0, 1, '0,600000000-677777777', 0,    0, -1, '', '');
-insert into return_states values ('faked', 'vmalloc', 0, 1, '0,600000000-677777777', 0, 103,  0, '\$', '1-128000000');
+insert into return_states values ('faked', 'vmalloc', 0, 1, '4096-ptr_max', 0,    0, -1, '', '');
+insert into return_states values ('faked', 'vmalloc', 0, 1, '4096-ptr_max', 0, 103,  0, '\$', '1-128000000');
 insert into return_states values ('faked', 'vmalloc', 0, 2, '0', 0,    0,  -1, '', '');
 
 delete from return_states where function = 'ksize';
@@ -141,9 +114,6 @@
 /* Just delete a lot of returns that everyone ignores */
 delete from return_states where file = 'drivers/pci/access.c' and (return >= 129 and return <= 137);
 
-update return_states set return = '(-4095)-s32max[<=\$1]' where function = 'get_user_pages' and return = 's32min-s32max';
-update return_states set return = '(-4095)-s64max[<=\$1]' where function = 'get_user_pages' and return = 's64min-s64max';
-
 /* Smatch can't parse wait_for_completion() */
 update return_states set return = '(-108),(-22),0' where function = '__spi_sync' and return = '(-115),(-108),(-22)';
 
@@ -155,9 +125,9 @@
 delete from caller_info where caller='init_fw_attribute_group' and function='(struct device_attribute)->show';
 /* and let's fake the next dev_attr_show() call entirely */
 delete from caller_info where caller='sysfs_kf_seq_show' and function='(struct sysfs_ops)->show';
-insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 1001, 0, '\$', '4096-2117777777777777777');
+insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 1001, 0, '\$', '4096-ptr_max');
 insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 1002, 2, '\$', '4096');
-insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 1001, 2, '\$', '4096-2117777777777777777');
+insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 1001, 2, '\$', '4096-ptr_max');
 insert into caller_info values ('fake', 'sysfs_kf_seq_show', '(struct sysfs_ops)->show', 0, 0, 0,   -1, ''  , '');
 /* config fs confuses smatch a little */
 update caller_info set value = 4096 where caller='fill_read_buffer' and function='(struct configfs_item_operations)->show_attribute' and type = 1002 and parameter = 2;
@@ -198,12 +168,18 @@
 /* this if from READ_ONCE().  We can't know anything about the data.  */
 delete from type_info where key = '(union anonymous)->__val';
 
+/* This is RIO_BAD_SIZE */
+delete from return_states where file = 'drivers/rapidio/rio-access.c' and return = '129';
+
+/* Smatch sucks at loops */
+delete from return_states where function = 'ata_dev_next' and type = 103;
+
 EOF
 
 # fixme: this is totally broken
 call_id=$(echo "select distinct call_id from caller_info where function = '__kernel_write';" | sqlite3 $db_file)
 for id in $call_id ; do
-    echo "insert into caller_info values ('fake', '', '__kernel_write', $id, 0, 1003, 1, '*\$', '');" | sqlite3 $db_file
+    echo "insert into caller_info values ('fake', '', '__kernel_write', $id, 0, 8017, 1, '*\$', '');" | sqlite3 $db_file
 done
 
 for i in $(echo "select distinct return from return_states where function = 'clear_user';" | sqlite3 $db_file ) ; do
@@ -227,3 +203,17 @@
          | sqlite3 $db_file
 done
 
+
+for func in __kmalloc __kmalloc_track_caller ; do
+
+    cat << EOF | sqlite3 $db_file
+delete from return_states where function = '$func';
+insert into return_states values ('faked', '$func', 0, 1, '16', 0,    0,  -1, '', '');
+insert into return_states values ('faked', '$func', 0, 1, '16', 0, 103,   0, '\$', '0');
+insert into return_states values ('faked', '$func', 0, 2, '4096-ptr_max', 0,    0, -1, '', '');
+insert into return_states values ('faked', '$func', 0, 2, '4096-ptr_max', 0, 103,  0, '\$', '1-4000000');
+insert into return_states values ('faked', '$func', 0, 2, '4096-ptr_max', 0, 1037,  -1, '', 400);
+insert into return_states values ('faked', '$func', 0, 3, '0', 0,    0,  -1, '', '');
+insert into return_states values ('faked', '$func', 0, 3, '0', 0,    103,  0, '\$', '1-long_max');
+EOF
+done
--- old/usr/src/tools/smatch/src/smatch_data/db/function_ptr.schema	Mon Aug  5 08:38:24 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/function_ptr.schema	Mon Aug  5 08:38:24 2019
@@ -1,1 +1,9 @@
-CREATE TABLE function_ptr (file varchar(128), function varchar(64), ptr varchar(256), searchable integer);
+CREATE TABLE function_ptr (
+	file varchar(128),
+	function varchar(64),
+	ptr varchar(256),
+	searchable integer,
+
+	CONSTRAINT function_ptr_constraint UNIQUE (file, function, ptr)
+);
+
--- old/usr/src/tools/smatch/src/smatch_data/db/init_constraints.pl	Mon Aug  5 08:38:24 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/init_constraints.pl	Mon Aug  5 08:38:24 2019
@@ -46,6 +46,10 @@
     my $project = shift;
     my $dir = dirname($full_path);
 
+    if ($project =~ /^$/) {
+        return;
+    }
+
     open(FILE, "$dir/$project.constraints");
     while (<FILE>) {
         s/\n//;
--- old/usr/src/tools/smatch/src/smatch_data/db/init_constraints_required.pl	Mon Aug  5 08:38:24 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/init_constraints_required.pl	Mon Aug  5 08:38:24 2019
@@ -34,6 +34,10 @@
     my $dir = dirname($full_path);
     my ($data, $op, $limit);
 
+    if ($project =~ /^$/) {
+        return;
+    }
+
     open(FILE, "$dir/$project.constraints_required");
     while (<FILE>) {
         ($data, $op, $limit) = split(/,/);
--- old/usr/src/tools/smatch/src/smatch_data/db/kernel.return_fixes	Mon Aug  5 08:38:24 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/kernel.return_fixes	Mon Aug  5 08:38:24 2019
@@ -11,7 +11,9 @@
 vscnprintf s32min-(-2),0-s32max[<$1] 0-s32max[<$1]
 down_interruptible s32min-s32max (-62),(-4)
 __sock_create s32min-(-1),1-s32max (-4095)-(-1)
+__sock_create s32min-(-90),(-88)-(-1),1-s32max (-4095)-(-90),(-88)-(-1)
 sock_create_kern s32min-(-1),1-s32max (-4095)-(-1)
+sock_create_kern s32min-(-90),(-88)-(-1),1-s32max (-4095)-(-90),(-88)-(-1)
 nilfs_cpfile_get_checkpoint_block s32min-(-18),(-16)-s32max (-4095)-(-18),(-16)-(-1)
 nilfs_cpfile_get_checkpoint_block s32min-(-18),(-16)-(-3),(-1),1-s32max (-4095)-(-18),(-16)-(-3),(-1)
 nilfs_mdt_insert_new_block s32min-(-23),(-21)-(-1),1-s32max (-4095)-(-23),(-21)-(-1)
@@ -19,8 +21,6 @@
 atomic_read s32min-s32max s32min-s32max[==$0->counter]
 notifier_to_errno (-2147483646)-(-1) (-4095)-(-1)
 mc_status_to_error s32min-s32max (-4095)-0
-dma_fence_wait_timeout s64min-s64max (-4095)-s64max
-dma_fence_wait_timeout s32min-s32max (-4095)-s32max
 fls s32min-s32max 0-32
 fls64 s64min-s64max 0-64
 __bitmap_weight s32min-s32max 0-s32max[<=$1]
@@ -27,8 +27,29 @@
 __bitmap_weight 0-s32max 0-s32max[<=$1]
 __ffs 0-u64max 0-63
 __ffs 0-u32max 0-31
+find_last_bit 0-u64max 0-u32max[<=$1]
 __spi_sync (-524),(-115),(-108),(-22) (-4095)-0
 tpm_tis_spi_read_bytes s32min-s32max (-4095)-0
 __irq_domain_activate_irq s32min-s32max (-4095)-0
-get_user_pages_fast s32min-s32max 1-s32max[<$1]
+get_user_pages_fast s32min-s32max 1-s32max[<=$1]
+get_user_pages s32min-s32max (-4095)-s32max[<=$1]
+get_user_pages s64min-s64max (-4095)-s64max[<=$1]
+get_user_pages_remote 1-s64max 1-s64max[<=$3]
+get_user_pages_remote (-133),(-14),(-12),1-s64max (-133),(-14),(-12),1-s64max[<=$3]
 __nci_request s32min-s32max (-4095)-0
+wait_for_common s64min-s64max 0-s64max[<=$1]
+wait_for_common 64min-(-1),1-s64max 1-s64max[<=$1]
+dma_fence_wait_timeout s64min-(-1),1-s64max (-4095)-(-1),1-s32max[<=2]
+dma_fence_wait_timeout s64min-s64max (-4095)-s32max
+dma_fence_wait_timeout s32min-s32max (-4095)-s32max
+__fw_state_wait_common s32min-s32max (-4095)-(-1)
+__ilog2_u32 s32min-s32max 0-31
+__ilog2_u64 s32min-s32max 0-63
+driver_attach s32min-s32max (-4095)-0
+mbox_post_sync_cmd 255 0-255
+mmc_io_rw_extended s32min-(-1),1-s32max (-4095)-(-1)
+kernel_read s64min-s64max (-4095)-1000000000
+security_kernel_post_read_file s32min-(-1),1-s32max (-4095)-(-1)
+array_index_mask_nospec 0-u64max u64max
+array_index_mask_nospec 0-u32max u32max
+nla_len (-4)-65531[$0->nla_len\ -\ 4] 0-65531[$0->nla_len\ -\ 4]
--- old/usr/src/tools/smatch/src/smatch_data/db/smdb.py	Mon Aug  5 08:38:25 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/smdb.py	Mon Aug  5 08:38:25 2019
@@ -17,6 +17,7 @@
 def usage():
     print "%s" %(sys.argv[0])
     print "<function> - how a function is called"
+    print "info <type> - how a function is called, filtered by type"
     print "return_states <function> - what a function returns"
     print "call_tree <function> - show the call tree"
     print "where <struct_type> <member> - where a struct member is set"
@@ -55,7 +56,6 @@
              104: "PARAM_FILTER",
             1001: "PARAM_VALUE",
             1002: "BUF_SIZE",
-            1003: "USER_DATA",
             1004: "CAPPED_DATA",
             1005: "RETURN_VALUE",
             1006: "DEREFERENCE",
@@ -79,7 +79,22 @@
             1027: "BYTE_UNITS",
             1028: "COMPARE_LIMIT",
             1029: "PARAM_COMPARE",
-            8017: "USER_DATA2",
+            1030: "EXPECTS_TYPE",
+            1031: "CONSTRAINT",
+            1032: "PASSES_TYPE",
+            1033: "CONSTRAINT_REQUIRED",
+            1034: "BIT_INFO",
+            1035: "NOSPEC",
+            1036: "NOSPEC_WB",
+            1037: "STMT_CNT",
+            1038: "TERMINATED",
+            1039: "SLEEP",
+            1040: "NO_SLEEP_CNT",
+            1041: "SMALLISH",
+            1042: "FRESH_MTAG",
+
+            8017: "USER_DATA",
+            9017: "USER_DATA_SET",
             8018: "NO_OVERFLOW",
             8019: "NO_OVERFLOW_SIMPLE",
             8020: "LOCKED",
@@ -197,6 +212,8 @@
         return 2**15 - 1
     elif txt == "u64max":
         return 2**64 - 1
+    elif txt == "ptr_max":
+        return 2**64 - 1
     elif txt == "u32max":
         return 2**32 - 1
     elif txt == "u16max":
@@ -589,6 +606,12 @@
 if len(sys.argv) == 2:
     func = sys.argv[1]
     print_caller_info("", func)
+elif sys.argv[1] == "info":
+    my_type = ""
+    if len(sys.argv) == 4:
+        my_type = sys.argv[3]
+    func = sys.argv[2]
+    print_caller_info("", func, my_type)
 elif sys.argv[1] == "call_info":
     if len(sys.argv) != 4:
         usage()
@@ -596,12 +619,6 @@
     func = sys.argv[3]
     caller_info_values(filename, func)
     print_caller_info(filename, func)
-elif sys.argv[1] == "user_data":
-    func = sys.argv[2]
-    print_caller_info(filename, func, "USER_DATA")
-elif sys.argv[1] == "param_value":
-    func = sys.argv[2]
-    print_caller_info(filename, func, "PARAM_VALUE")
 elif sys.argv[1] == "function_ptr" or sys.argv[1] == "fn_ptr":
     func = sys.argv[2]
     print_fn_ptrs(func)
--- old/usr/src/tools/smatch/src/smatch_data/db/vim_smdb	Mon Aug  5 08:38:25 2019
+++ new/usr/src/tools/smatch/src/smatch_data/db/vim_smdb	Mon Aug  5 08:38:25 2019
@@ -25,7 +25,7 @@
 next=$(($i + 1))
 
 rm -f $DIR/$next
-rm $DIR/.${i}.swp
+rm -f $DIR/.${i}.swp
 smdb $* > $DIR/$i
 
 echo "$DIR/$i" > $DIR/cur
--- old/usr/src/tools/smatch/src/smatch_data/illumos_kernel.skipped_functions	Mon Aug  5 08:38:25 2019
+++ new/usr/src/tools/smatch/src/smatch_data/illumos_kernel.skipped_functions	Mon Aug  5 08:38:25 2019
@@ -1,8 +1,13 @@
 /* These are "too hairy" for smatch. */
+ECDSA_VerifyDigest
 dtrace_disx86
 elf32exec
 elfexec
 iscsi_ioctl
 lm_idle_chk
+ld64_sym_validate
+luaV_settable
+nostore_generate_key_pair
+sadb_common_add
 segvn_fault_vnodepages
 tcp_input_data
--- old/usr/src/tools/smatch/src/smatch_data/illumos_user.skipped_functions	Mon Aug  5 08:38:26 2019
+++ new/usr/src/tools/smatch/src/smatch_data/illumos_user.skipped_functions	Mon Aug  5 08:38:26 2019
@@ -24,8 +24,12 @@
 AslCompilerparse
 /* cmd/fs.d/autofs */
 nfsmount
+/* cmd/mdb */
+iob_doprnt
 /* cmd/pppd */
 lcp_nakci
+/* cmd/cmd-crypto */
+execute_cmd
 
 /* generated code */
 ipf_yyparse
--- old/usr/src/tools/smatch/src/smatch_data/kernel.allocation_funcs_gfp.remove	Mon Aug  5 08:38:26 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.allocation_funcs_gfp.remove	Mon Aug  5 08:38:26 2019
@@ -1,2 +1,3 @@
+acquire_group
 acquire_group 2
 acquire_group X
--- /dev/null	Mon Aug  5 08:38:26 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.ignore_casted_params	Mon Aug  5 08:38:26 2019
@@ -0,0 +1,15 @@
+set_bit
+clear_bit
+__clear_bit
+__set_bit
+test_and_set_bit
+find_last_bit
+change_bit
+xfs_next_bit
+find_next_bit
+find_first_bit
+__test_and_set_bit
+sync_set_bit
+bitmap_weight
+bitmap_intersects
+bitmap_empty
--- old/usr/src/tools/smatch/src/smatch_data/kernel.ignore_side_effects	Mon Aug  5 08:38:26 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.ignore_side_effects	Mon Aug  5 08:38:26 2019
@@ -53,6 +53,8 @@
 RCU_INIT_POINTER
 READ64
 rtnl_dereference
+SK_REUSEPORT_LOAD_SKB_FIELD
+SK_REUSEPORT_LOAD_SK_FIELD_SIZE_OFF
 send_bits
 send_code
 SOCK_ADDR_LOAD_NESTED_FIELD
@@ -59,6 +61,8 @@
 SOCK_ADDR_LOAD_NESTED_FIELD_SIZE_OFF
 SOCK_ADDR_LOAD_OR_STORE_NESTED_FIELD_SIZE_OFF
 SOCK_ADDR_LOAD_OR_STORE_NESTED_FIELD
+SOCK_OPS_GET_FIELD
+SOCK_OPS_GET_OR_SET_FIELD
 SOCK_OPS_GET_TCP32
 unsafe_get_user
 unsafe_put_user
--- old/usr/src/tools/smatch/src/smatch_data/kernel.ignore_uninitialized_param	Mon Aug  5 08:38:26 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.ignore_uninitialized_param	Mon Aug  5 08:38:26 2019
@@ -102,3 +102,10 @@
 pwrap_read 2
 dibusb_read_eeprom_byte 2
 of_fdt_unflatten_tree 2
+pci_user_read_config_byte 2
+gen11_gu_misc_irq_ack 2
+vsc73xx_read 4
+smb_hc_read 2
+smb_word_op 5
+atl1c_read_phy_reg 2
+adf7242_read_reg 2
--- /dev/null	Mon Aug  5 08:38:27 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.ignored_warnings	Mon Aug  5 08:38:27 2019
@@ -0,0 +1,1 @@
+check_shift_to_zero overflows_type
--- old/usr/src/tools/smatch/src/smatch_data/kernel.no_inline_functions	Mon Aug  5 08:38:27 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.no_inline_functions	Mon Aug  5 08:38:27 2019
@@ -10,3 +10,5 @@
 __arch_hweight64
 __write_once_size
 atomic_set
+atomic_read
+notifier_to_errno
--- /dev/null	Mon Aug  5 08:38:27 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.no_return_funcs.add	Mon Aug  5 08:38:27 2019
@@ -0,0 +1,2 @@
+YY_FATAL_ERROR
+malformed_line
--- old/usr/src/tools/smatch/src/smatch_data/kernel.silenced_functions	Mon Aug  5 08:38:27 2019
+++ new/usr/src/tools/smatch/src/smatch_data/kernel.silenced_functions	Mon Aug  5 08:38:27 2019
@@ -4,7 +4,6 @@
 atomic64_dec_and_test
 atomic_sub_and_test
 test_and_clear_bit
-test_and_set_bit
 __copy_to_user_nocheck
 __copy_from_user_nocheck
 arch_static_branch
--- old/usr/src/tools/smatch/src/smatch_data_source.c	Mon Aug  5 08:38:28 2019
+++ new/usr/src/tools/smatch/src/smatch_data_source.c	Mon Aug  5 08:38:28 2019
@@ -24,6 +24,7 @@
 static char *get_source_parameter(struct expression *expr)
 {
 	struct expression *tmp;
+	const char *param_name;
 	struct symbol *sym;
 	char *name;
 	int param;
@@ -30,6 +31,7 @@
 	char *ret = NULL;
 	char buf[32];
 	int cnt = 0;
+	bool modified = false;
 
 	tmp = expr;
 	while ((tmp = get_assigned_expr(tmp))) {
@@ -48,10 +50,14 @@
 	param = get_param_num_from_sym(sym);
 	if (param < 0)
 		goto free;
-	if (param_was_set(expr))
+	param_name = get_param_name_var_sym(name, sym);
+	if (!param_name)
 		goto free;
+	if (param_was_set_var_sym(name, sym))
+		modified = true;
 
-	snprintf(buf, sizeof(buf), "p %d", param);
+	snprintf(buf, sizeof(buf), "$%d%s%s", param, param_name + 1,
+		 modified ? " [m]" : "");
 	ret = alloc_string(buf);
 
 free:
